/*
rg_graceacc.js - Example of webpage conversion to NWC User Tool v1.0
Ref: http://home.comcast.net/~wporter211/realsite/graceacc.htm
*/
function nsort(a,b) { return parseInt(a.slice(1)) - parseInt(b.slice(1)); } //Needed for descending strum
/*
Add clip as function parameter so it can be sent stdin
*/
function calculate(clip) {
  var seltab = new Array(), PosTab = new Array();
  var i, j, k, OutText = "", begChord = "", endChord = "";
  var cntNotes=0, begpnt, endpnt;
  var lines = new Array();
	/*
  lines = document.nwcform.OutputField.value.split("\n");
	there is no document object in CScript, so this need to be replaced with:
	*/
	lines = clip.split("\r\n");

  for (i=0; i < lines.length; i++) {
    if  (/Note.*Grace.+\:[#bn].+\^/.test(lines[i])) {  // Thanks to Declan1991 of webdeveloper.com for help here.
      begpnt = lines[i].search(/[#bn]-*\d+/);
	  endpnt = lines[i].search(/\^/);
	  seltab[cntNotes++] = lines[i].substr(begpnt, endpnt-begpnt);
	}
	if (/Chord/.test(lines[i]) && (cntNotes > 0)) {  // If cntNotes == 0, do nothing on this Chord
	  seltab.sort(nsort);  // In case of descending or random strum (arpeggios).
	  endpnt = lines[i].search(/Pos:/);
	  begChord = lines[i].slice(0,endpnt+4);
	  endChord = lines[i].slice(endpnt+4);
	  PosTab = endChord.split(",");
//	  alert("PosTab = " + PosTab);
	  k = 0;
	  for (j = 0; j < cntNotes; j++) {
//	   	alert("j= " + j + " k= " + k + " seltab[j] = " + parseInt(seltab[j].slice(1)) + " PosTab[k] = " + parseInt(PosTab[k]));
		while (parseInt(seltab[j].slice(1)) > parseInt(PosTab[k])) k++;
		if (parseInt(seltab[j].slice(1)) < parseInt(PosTab[k])) // Tied grace note wasn't in the chord.
		  {alert("Severe logic error"); return 1;}   // I can't deal with it anymore.
//		alert("j= " + j + " k= " + k + " seltab[j] = " + parseInt(seltab[j].slice(1)) + " PosTab[k] = " + parseInt(PosTab[k]));
		PosTab[k++] = seltab[j];
	  }
	  endChord = "";
	  for (j=0; j < PosTab.length; j++) {
	    endChord += PosTab[j];
		if (PosTab.length - j > 1)
		  endChord += ",";
	  }
	  lines[i] = begChord + endChord;
//	alert(lines[i] + " after replacement");
	cntNotes = 0;  // Get ready for next batch
	for (k=0; k < seltab.length; k++) seltab[k]="";
	seltab.length = 0;
    for (k=0; k < PosTab.length; k++) PosTab[k]="";
	PosTab.length = 0;
	}  // End of processing chord needing work
  }  //End of lines[]
	/*
	Again, there is no doument. This not needed:
   document.nwcform.OutputField.value = "" //To rebuild textarea
   for (i = 0 ; i < lines.length; i++) {
     document.nwcform.OutputField.value += lines[i];
     if ((cntNotes - i) > 1)
       document.nwcform.OutputField.value += "\n";
   }
  document.nwcform.OutputField.select();   //Pre selected for Cntl/C
	Instead,use:
	*/
	return lines;
}   //End of function
/*
Execution begins here:
*/
WScript.StdOut.Write(calculate(WScript.StdIn.ReadAll()).join("\r\n"));
